import { User } from '@/models/user.ts';
import http from 'http';

export const error = (msg: string, code = 500) => {
  return JSON.stringify({ code, message: msg });
};
export const checkAuth = async (req: http.IncomingMessage, res: http.ServerResponse) => {
  let token = '';
  const authroization = req.headers?.['authorization'] as string;
  const url = new URL(req.url || '', 'http://localhost');
  const resNoPermission = () => {
    res.statusCode = 401;
    res.end(error('Invalid authorization'));
    return { tokenUser: null, token: null };
  };
  if (authroization) {
    // return resNoPermission();
    token = authroization.split(' ')[1];
  } else if (url.searchParams.get('token')) {
    token = url.searchParams.get('token') || '';
  } else {
    return resNoPermission();
  }
  let tokenUser;
  try {
    tokenUser = await User.verifyToken(token);
  } catch (e) {
    res.statusCode = 401;
    res.end(error('Invalid token'));
    return { tokenUser: null, token: null };
  }
  return { tokenUser, token };
};
